#include "stdafx.h"
#include "CNmx.h"


CNmx::CNmx()
{
}


CNmx::~CNmx()
{
}


bool CNmx::Load()
{
	BOOL bReturn = true;

	/* Try to load the Nmx library */
#ifdef _M_X64 
	hNmxDll = LoadLibrary((LPCWSTR)L".\\NmxDllx64.dll");
#else 
	hNmxDll = LoadLibrary((LPCWSTR)L".\\NmxDllx86.dll");
#endif 
	if (hNmxDll == NULL)
	{
		return false;
	}
	
	/* Load DLL functions */
	GetDllVersion_1 = (T_NMX_GetDllVersion_1)GetProcAddress(hNmxDll, "NMX_GetDllVersion_1");
	if (GetDllVersion_1 == NULL) bReturn = false;

	DeviceIPv4Open_1 = (T_NMX_DeviceIPv4Open_1)GetProcAddress(hNmxDll, "NMX_DeviceIPv4Open_1");
	if (DeviceIPv4Open_1 == NULL) bReturn = false;

	DeviceClose_1 = (T_NMX_DeviceClose_1)GetProcAddress(hNmxDll, "NMX_DeviceClose_1");
	if (DeviceClose_1 == NULL) bReturn = false;

	GetBoxCount_1 = (T_NMX_GetBoxCount_1)GetProcAddress(hNmxDll, "NMX_GetBoxCount_1");
	if (GetBoxCount_1 == NULL) bReturn = false;

	GetBoxInfo_1 = (T_NMX_GetBoxInfo_1)GetProcAddress(hNmxDll, "NMX_GetBoxInfo_1");
	if (GetBoxInfo_1 == NULL) bReturn = false;

	UpdateChannelInfo_1 = (T_NMX_UpdateChannelInfo_1)GetProcAddress(hNmxDll, "NMX_UpdateChannelInfo_1");
	if (UpdateChannelInfo_1 == NULL) bReturn = false;

	GetChannelCount_1 = (T_NMX_GetChannelCount_1)GetProcAddress(hNmxDll, "NMX_GetChannelCount_1");
	if (GetChannelCount_1 == NULL) bReturn = false;

	GetChannelInfo_1 = (T_NMX_GetChannelInfo_1)GetProcAddress(hNmxDll, "NMX_GetChannelInfo_1");
	if (GetChannelInfo_1 == NULL) bReturn = false;

	GetDigitalInputInfo_1 = (T_NMX_GetDigitalInputInfo_1)GetProcAddress(hNmxDll, "NMX_GetDigitalInputInfo_1");
	if (GetDigitalInputInfo_1 == NULL) bReturn = false;

	GetDigitalOutputInfo_1 = (T_NMX_GetDigitalOutputInfo_1)GetProcAddress(hNmxDll, "NMX_GetDigitalOutputInfo_1");
	if (GetDigitalOutputInfo_1 == NULL) bReturn = false;

	RegisterMessage_1 = (T_NMX_RegisterMessage_1)GetProcAddress(hNmxDll, "NMX_RegisterMessage_1");
	if (RegisterMessage_1 == NULL) bReturn = false;

	RegisterCallback_1 = (T_NMX_RegisterCallback_1)GetProcAddress(hNmxDll, "NMX_RegisterCallback_1");
	if (RegisterCallback_1 == NULL) bReturn = false;

	ChannelSetParameter_1 = (T_NMX_ChannelSetParameter_1)GetProcAddress(hNmxDll, "NMX_ChannelSetParameter_1");
	if (ChannelSetParameter_1 == NULL) bReturn = false;

	ChannelSetConfig_1 = (T_NMX_ChannelSetConfig_1)GetProcAddress(hNmxDll, "NMX_ChannelSetConfig_1");
	if (ChannelSetConfig_1 == NULL) bReturn = false;

	StaticGet32_1 = (T_NMX_StaticGet32_1)GetProcAddress(hNmxDll, "NMX_StaticGet32_1");
	if (StaticGet32_1 == NULL) bReturn = false;

	StaticSetMedianDepth_1 = (T_NMX_StaticSetMedianDepth_1)GetProcAddress(hNmxDll, "NMX_StaticSetMedianDepth_1");
	if (StaticSetMedianDepth_1 == NULL) bReturn = false;

	SetOutputs_1 = (T_NMX_SetOutputs_1)GetProcAddress(hNmxDll, "NMX_SetOutputs_1");
	if (SetOutputs_1 == NULL) bReturn = false;

	DisableOutputUpdate_1 = (T_NMX_DisableOutputUpdate_1)GetProcAddress(hNmxDll, "NMX_DisableOutputUpdate_1");
	if (DisableOutputUpdate_1 == NULL) bReturn = false;

	DigitalIoConfig_1 = (T_NMX_DigitalIoConfig_1)GetProcAddress(hNmxDll, "NMX_DigitalIoConfig_1");
	if (DigitalIoConfig_1 == NULL) bReturn = false;

	DigitalOutputsGetState_1 = (T_NMX_DigitalOutputsGetState_1)GetProcAddress(hNmxDll, "NMX_DigitalOutputsGetState_1");
	if (DigitalOutputsGetState_1 == NULL) bReturn = false;

	Sampling_GetMaxSpeed_1 = (T_NMX_Sampling_GetMaxSpeed_1)GetProcAddress(hNmxDll, "NMX_Sampling_GetMaxSpeed_1");
	if (Sampling_GetMaxSpeed_1 == NULL) bReturn = false;

	Sampling_Reset_1 = (T_NMX_Sampling_Reset_1)GetProcAddress(hNmxDll, "NMX_Sampling_Reset_1");
	if (Sampling_Reset_1 == NULL) bReturn = false;

	Sampling_AddChannelsAll_1 = (T_NMX_Sampling_AddChannelsAll_1)GetProcAddress(hNmxDll, "NMX_Sampling_AddChannelsAll_1");
	if (Sampling_AddChannelsAll_1 == NULL) bReturn = false;

	Sampling_AddChannel_1 = (T_NMX_Sampling_AddChannel_1)GetProcAddress(hNmxDll, "NMX_Sampling_AddChannel_1");
	if (Sampling_AddChannel_1 == NULL) bReturn = false;

	Sampling_AddDigiInAll_1 = (T_NMX_Sampling_AddDigiInAll_1)GetProcAddress(hNmxDll, "NMX_Sampling_AddDigiInAll_1");
	if (Sampling_AddDigiInAll_1 == NULL) bReturn = false;

	Sampling_AddDigiInByte_1 = (T_NMX_Sampling_AddDigiInByte_1)GetProcAddress(hNmxDll, "NMX_Sampling_AddDigiInByte_1");
	if (Sampling_AddDigiInByte_1 == NULL) bReturn = false;

	Sampling_AddDigiOutAll_1 = (T_NMX_Sampling_AddDigiOutAll_1)GetProcAddress(hNmxDll, "NMX_Sampling_AddDigiOutAll_1");
	if (Sampling_AddDigiOutAll_1 == NULL) bReturn = false;

	Sampling_AddDigiOutByte_1 = (T_NMX_Sampling_AddDigiOutByte_1)GetProcAddress(hNmxDll, "NMX_Sampling_AddDigiOutByte_1");
	if (Sampling_AddDigiOutByte_1 == NULL) bReturn = false;

	Sampling_SetTriggerDigiIn_1 = (T_NMX_Sampling_SetTriggerDigiIn_1)GetProcAddress(hNmxDll, "NMX_Sampling_SetTriggerDigiIn_1");
	if (Sampling_SetTriggerDigiIn_1 == NULL) bReturn = false;

	Sampling_PrepareTime_1 = (T_NMX_Sampling_PrepareTime_1)GetProcAddress(hNmxDll, "NMX_Sampling_PrepareTime_1");
	if (Sampling_PrepareTime_1 == NULL) bReturn = false;

	Sampling_PrepareCustomTFT_1 = (T_NMX_Sampling_PrepareCustomTFT_1)GetProcAddress(hNmxDll, "NMX_Sampling_PrepareCustomTFT_1");
	if (Sampling_PrepareCustomTFT_1 == NULL) bReturn = false;

	Sampling_PreparePosition_1 = (T_NMX_Sampling_PreparePosition_1)GetProcAddress(hNmxDll, "NMX_Sampling_PreparePosition_1");
	if (Sampling_PreparePosition_1 == NULL) bReturn = false;

	Sampling_Start_1 = (T_NMX_Sampling_Start_1)GetProcAddress(hNmxDll, "NMX_Sampling_Start_1");
	if (Sampling_Start_1 == NULL) bReturn = false;

	Sampling_Stop_1 = (T_NMX_Sampling_Stop_1)GetProcAddress(hNmxDll, "NMX_Sampling_Stop_1");
	if (Sampling_Stop_1 == NULL) bReturn = false;

	Sampling_ReadColumn32_1 = (T_NMX_Sampling_ReadColumn32_1)GetProcAddress(hNmxDll, "NMX_Sampling_ReadColumn32_1");
	if (Sampling_ReadColumn32_1 == NULL) bReturn = false;

	Sampling_ReadRow32_1 = (T_NMX_Sampling_ReadRow32_1)GetProcAddress(hNmxDll, "NMX_Sampling_ReadRow32_1");
	if (Sampling_ReadRow32_1 == NULL) bReturn = false;

	Sampling_GetStatus_1 = (T_NMX_Sampling_GetStatus_1)GetProcAddress(hNmxDll, "NMX_Sampling_GetStatus_1");
	if (Sampling_GetStatus_1 == NULL) bReturn = false;

	DiagClearEvent_1 = (T_NMX_DiagClearEvent_1)GetProcAddress(hNmxDll, "NMX_DiagClearEvent_1");
	if (DiagClearEvent_1 == NULL) bReturn = false;

	DiagGetEventText_1 = (T_NMX_DiagGetEventText_1)GetProcAddress(hNmxDll, "NMX_DiagGetEventText_1");
	if (DiagGetEventText_1 == NULL) bReturn = false;

	SetDateTime_1 = (T_NMX_SetDateTime_1)GetProcAddress(hNmxDll, "NMX_SetDateTime_1");
	if (SetDateTime_1 == NULL) bReturn = false;

	return bReturn;
}
